<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<meta name="robots" content="NOINDEX, NOFOLLOW" /> <!-- Prevent indexing by search engines -->
<title>ARM Compute Library: arm_compute/core/CL/ICLArray.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">ARM Compute Library
   &#160;<span id="projectnumber">17.04</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.xhtml"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.xhtml"><span>Namespaces</span></a></li>
      <li><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.xhtml"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.xhtml"><span>File&#160;List</span></a></li>
      <li><a href="globals.xhtml"><span>Globals</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_i_c_l_array_8h_source.xhtml','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">ICLArray.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_i_c_l_array_8h.xhtml">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2016, 2017 ARM Limited.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * SPDX-License-Identifier: MIT</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a copy</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * of this software and associated documentation files (the &quot;Software&quot;), to</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * deal in the Software without restriction, including without limitation the</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * sell copies of the Software, and to permit persons to whom the Software is</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * furnished to do so, subject to the following conditions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * The above copyright notice and this permission notice shall be included in all</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * copies or substantial portions of the Software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> * SOFTWARE.</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#ifndef __ARM_COMPUTE_ICLARRAY_H__</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#define __ARM_COMPUTE_ICLARRAY_H__</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_open_c_l_8h.xhtml">arm_compute/core/CL/OpenCL.h</a>&quot;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_i_array_8h.xhtml">arm_compute/core/IArray.h</a>&quot;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_i_tensor_8h.xhtml">arm_compute/core/ITensor.h</a>&quot;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacearm__compute.xhtml">arm_compute</a></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;{</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_i_c_l_array.xhtml">   35</a></span>&#160;<span class="keyword">class </span><a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray</a> : <span class="keyword">public</span> <a class="code" href="classarm__compute_1_1_i_array.xhtml">IArray</a>&lt;T&gt;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;{</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="comment">/* Constructor */</span></div><div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_i_c_l_array.xhtml#a52adc23eae121bce4ce2f3febaf77566">   39</a></span>&#160;    <span class="keyword">explicit</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml#a52adc23eae121bce4ce2f3febaf77566">ICLArray</a>(<span class="keywordtype">size_t</span> <a class="code" href="classarm__compute_1_1_i_array.xhtml#a2ff0fb106d58091d2b4363e808f200a3">max_num_values</a>)</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        : <a class="code" href="classarm__compute_1_1_i_array.xhtml">IArray</a>&lt;T&gt;(max_num_values), _mapping(nullptr)</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    {</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    }</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml#a52adc23eae121bce4ce2f3febaf77566">ICLArray</a>(<span class="keyword">const</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray</a> &amp;) = <span class="keyword">delete</span>;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray</a> &amp;<a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml#aefdb6cfe839aa0835406d5adcd37de5b">operator=</a>(<span class="keyword">const</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray</a> &amp;) = <span class="keyword">delete</span>;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml#a0c95f444049eea7c7d14f6fd57ef40a1">~ICLArray</a>()                   = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keyword">virtual</span> <span class="keyword">const</span> cl::Buffer &amp;<a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml#a1fb4c50755a0ef424652246838ed91a6">cl_buffer</a>() <span class="keyword">const</span> = 0;</div><div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_i_c_l_array.xhtml#ac0abc7a5c0d172947f0e6a0c0dde3df0">   61</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml#ac0abc7a5c0d172947f0e6a0c0dde3df0">map</a>(cl::CommandQueue &amp;q, <span class="keywordtype">bool</span> blocking = <span class="keyword">true</span>)</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    {</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        _mapping = do_map(q, blocking);</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    }</div><div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_i_c_l_array.xhtml#af974a2360069c2ef8df4496d00e4f6cc">   72</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml#af974a2360069c2ef8df4496d00e4f6cc">unmap</a>(cl::CommandQueue &amp;q)</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    {</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        do_unmap(q, _mapping);</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        _mapping = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    }</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="comment">// Inherited methods overridden:</span></div><div class="line"><a name="l00079"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_i_c_l_array.xhtml#a46fdef12397c4404e7706cba3568b42d">   79</a></span>&#160;    T *<a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml#a46fdef12397c4404e7706cba3568b42d">buffer</a>()<span class="keyword"> const override</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="keyword">    </span>{</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">reinterpret_cast&lt;</span>T *<span class="keyword">&gt;</span>(_mapping);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    }</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keyword">virtual</span> uint8_t *do_map(cl::CommandQueue &amp;q, <span class="keywordtype">bool</span> blocking) = 0;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> do_unmap(cl::CommandQueue &amp;q, uint8_t *mapping) = 0;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    uint8_t *_mapping;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;};</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div><div class="line"><a name="l00107"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#adb969f0e554bf563f2fa671399d59280">  107</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLKeyPointArray</a>        = <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray&lt;KeyPoint&gt;</a>;</div><div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#adf4063963bf3a4b07a5d0cc840da9ee2">  108</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLCoordinates2DArray</a>   = <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray&lt;Coordinates2D&gt;</a>;</div><div class="line"><a name="l00109"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a4cc908807b0a45ccc6ce7ba340ae2259">  109</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLDetectionWindowArray</a> = <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray&lt;DetectionWindow&gt;</a>;</div><div class="line"><a name="l00110"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a68396eee600b3d23bf7f95a802e65dff">  110</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLSize2DArray</a>          = <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray&lt;Size2D&gt;</a>;</div><div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a72251c7a73b3c057ffca9f32ee3e19ea">  111</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLUInt8Array</a>           = <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray&lt;cl_uchar&gt;</a>;</div><div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#aed5c7222c31a34327f00de37d8c4f4fc">  112</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLUInt16Array</a>          = <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray&lt;cl_ushort&gt;</a>;</div><div class="line"><a name="l00113"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a6b5f839e8d27c6351e8d58812dd46c97">  113</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLUInt32Array</a>          = <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray&lt;cl_uint&gt;</a>;</div><div class="line"><a name="l00114"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a67328fa21e30aecd0c27d6d2e63a2b9c">  114</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLInt16Array</a>           = <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray&lt;cl_short&gt;</a>;</div><div class="line"><a name="l00115"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#ab95380ecf1c0253f6c785c0f59194066">  115</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLInt32Array</a>           = <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray&lt;cl_int&gt;</a>;</div><div class="line"><a name="l00116"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a631bac7c033a0d341c631870f9755217">  116</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLFloatArray</a>           = <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray&lt;cl_float&gt;</a>;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;}</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/*__ARM_COMPUTE_ICLARRAY_H__*/</span><span class="preprocessor"></span></div><div class="ttc" id="_i_tensor_8h_xhtml"><div class="ttname"><a href="_i_tensor_8h.xhtml">ITensor.h</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_array_xhtml_a52adc23eae121bce4ce2f3febaf77566"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_array.xhtml#a52adc23eae121bce4ce2f3febaf77566">arm_compute::ICLArray::ICLArray</a></div><div class="ttdeci">ICLArray(size_t max_num_values)</div><div class="ttdef"><b>Definition:</b> <a href="_i_c_l_array_8h_source.xhtml#l00039">ICLArray.h:39</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_array_xhtml"><div class="ttname"><a href="classarm__compute_1_1_i_array.xhtml">arm_compute::IArray</a></div><div class="ttdoc">Array of type T. </div><div class="ttdef"><b>Definition:</b> <a href="_i_array_8h_source.xhtml#l00040">IArray.h:40</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_array_xhtml_ac0abc7a5c0d172947f0e6a0c0dde3df0"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_array.xhtml#ac0abc7a5c0d172947f0e6a0c0dde3df0">arm_compute::ICLArray::map</a></div><div class="ttdeci">void map(cl::CommandQueue &amp;q, bool blocking=true)</div><div class="ttdoc">Enqueue a map operation of the allocated buffer on the given queue. </div><div class="ttdef"><b>Definition:</b> <a href="_i_c_l_array_8h_source.xhtml#l00061">ICLArray.h:61</a></div></div>
<div class="ttc" id="namespacearm__compute_xhtml"><div class="ttname"><a href="namespacearm__compute.xhtml">arm_compute</a></div><div class="ttdef"><b>Definition:</b> <a href="arm__compute_8dox_source.xhtml#l00001">arm_compute.dox:1</a></div></div>
<div class="ttc" id="_i_array_8h_xhtml"><div class="ttname"><a href="_i_array_8h.xhtml">IArray.h</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_array_xhtml"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_array.xhtml">arm_compute::ICLArray</a></div><div class="ttdoc">Interface for OpenCL Array. </div><div class="ttdef"><b>Definition:</b> <a href="_i_c_l_array_8h_source.xhtml#l00035">ICLArray.h:35</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_array_xhtml_a0c95f444049eea7c7d14f6fd57ef40a1"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_array.xhtml#a0c95f444049eea7c7d14f6fd57ef40a1">arm_compute::ICLArray::~ICLArray</a></div><div class="ttdeci">virtual ~ICLArray()=default</div></div>
<div class="ttc" id="classarm__compute_1_1_i_array_xhtml_a2ff0fb106d58091d2b4363e808f200a3"><div class="ttname"><a href="classarm__compute_1_1_i_array.xhtml#a2ff0fb106d58091d2b4363e808f200a3">arm_compute::IArray::max_num_values</a></div><div class="ttdeci">size_t max_num_values() const </div><div class="ttdoc">Maximum number of values which can be stored in this array. </div><div class="ttdef"><b>Definition:</b> <a href="_i_array_8h_source.xhtml#l00058">IArray.h:58</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_array_xhtml_aefdb6cfe839aa0835406d5adcd37de5b"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_array.xhtml#aefdb6cfe839aa0835406d5adcd37de5b">arm_compute::ICLArray::operator=</a></div><div class="ttdeci">ICLArray &amp; operator=(const ICLArray &amp;)=delete</div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_array_xhtml_af974a2360069c2ef8df4496d00e4f6cc"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_array.xhtml#af974a2360069c2ef8df4496d00e4f6cc">arm_compute::ICLArray::unmap</a></div><div class="ttdeci">void unmap(cl::CommandQueue &amp;q)</div><div class="ttdoc">Enqueue an unmap operation of the allocated and mapped buffer on the given queue. ...</div><div class="ttdef"><b>Definition:</b> <a href="_i_c_l_array_8h_source.xhtml#l00072">ICLArray.h:72</a></div></div>
<div class="ttc" id="_open_c_l_8h_xhtml"><div class="ttname"><a href="_open_c_l_8h.xhtml">OpenCL.h</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_array_xhtml_a46fdef12397c4404e7706cba3568b42d"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_array.xhtml#a46fdef12397c4404e7706cba3568b42d">arm_compute::ICLArray::buffer</a></div><div class="ttdeci">T * buffer() const override</div><div class="ttdoc">Pointer to the first element of the array. </div><div class="ttdef"><b>Definition:</b> <a href="_i_c_l_array_8h_source.xhtml#l00079">ICLArray.h:79</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_array_xhtml_a1fb4c50755a0ef424652246838ed91a6"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_array.xhtml#a1fb4c50755a0ef424652246838ed91a6">arm_compute::ICLArray::cl_buffer</a></div><div class="ttdeci">virtual const cl::Buffer &amp; cl_buffer() const =0</div><div class="ttdoc">Interface to be implemented by the child class to return a reference to the OpenCL buffer containing ...</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_214608ef36d61442cb2b0c1c4e9a7def.xhtml">arm_compute</a></li><li class="navelem"><a class="el" href="dir_1fb090f0c6070330bfaccc4236d3ca0d.xhtml">core</a></li><li class="navelem"><a class="el" href="dir_1633709b037eda5b8477677909f78129.xhtml">CL</a></li><li class="navelem"><a class="el" href="_i_c_l_array_8h.xhtml">ICLArray.h</a></li>
    <li class="footer">Generated on Wed Apr 12 2017 17:30:09 for ARM Compute Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
